(* 10.2.1997                                                               *)
(* Gedrehte Polygone, deren Umkreisradius auch noch verkuerzt wird.        *)
(* Ein Quadrat wird 1 1/2 Mal um sich selbst in das Endquadrat gedreht     *)
PROGRAM  Poly5;    
USES CRT,UNIGRA12;

CONST
MaxNNPts = 20;                        (* maximale Eckenzahl eines Polygons *)

TYPE Polygon = RECORD
                 NNPts: INTEGER;                (* tatsaechliche Eckenzahl *)
                 PtA: ARRAY[1..MaxNNPts] OF Pt2D;
               END;

VAR
  Plg1 : Polygon;
  
{ ------------------------- Unterprogramme ------------------------------ }
Procedure Ausgangszustand_definieren;
   BEGIN
   Plotter_einschalten;
   Graphik_einschalten('');
   Weltgrenzen_festlegen(einh);  
   Viewport_festlegen;
   GeraetefensterPlotter_festlegen;
   Parameter2D;
   Portrait  := FALSE;                   (* Querformat Bild liegend        *)
   Plast.X := WI2D[1].X;                 (* letzter Punkt initialisieren   *)
   Plast.Y := WI2D[1].Y;
   Viewport_zeichnen;
   {Koordinatenachsen_zeichnen;} 
  { Gitter(0.3,2.0,10.0);}(* Strich,              klE,             grE     *)
                       (* grosse Strichlaenge,kleine Einheit, grosse Einh *)
  END;
                      
Procedure Beschriftung(Ecken,JJ:INTEGER;AD,Alpha,F,R0,T0: EXTENDED; M: Pt2D);
  VAR
  T: Ttyp;
  XUntergr,XObergr,YUntergr,YObergr,einhS : STRING[Bz1];
  EckenS,JJS,ADS,AlphaS,FS,R0S,T0S,MXS,MYS: STRING[Bz1];
  Ttemp1,Ttemp2: STRING[Bz2];
  BEGIN
  STR(WI2D[1].X:5:1,XUntergr); STR(WI2D[1].Y:5:1,YUntergr);
  STR(WI2D[2].X:5:1,XObergr);  STR(WI2D[2].Y:5:1,YObergr);
  STR(einh:5:3,einhS);
  STR(Ecken:2,EckenS);  STR(JJ:3,JJS);
  STR(AD:5:3,ADS); STR(Alpha:5:3,AlphaS);  STR(F:5:3,FS); STR(R0:5:3,R0S);
  STR(M.X:5:3,MXS);  STR(M.Y:5:3,MYS);  STR(T0:5:2,T0S);
(* ------------------------------- TEXTE --------------------------------- *)
  T[1] := 'Es werden insgesamt '+JJS+' '+EckenS+'-Ecke gezeichnet';
  T[2] := 'Ein'+EckenS+'-Eck wird jeweils um '+AlphaS+' Grad  gedreht';
        Ttemp1 := 'Mittelpunkt: '+MXS+'/'+MYS+'     Radius: '+R0S;
        Ttemp2 := ' des ersten Polygonumkreises';
  T[3] := Ttemp1 + Ttemp2;
        Ttemp1 := 'Das AusgangsPolygon wird '+ADS+' Mal um sich selbst ';
        Ttemp2 := 'ins Endpolygon gedreht';
  T[4] := Ttemp1 + Ttemp2;
        Ttemp1 := 'Winkelversatz der ersten Ecke: '+T0S+' Grad  ';
        Ttemp2 := 'Verkuerzungsfaktor des Radius: '+FS;
  T[5] := Ttemp1 + Ttemp2;
        Ttemp1 := 'Weltgrenzen: X von '+XUntergr+' bis '+XObergr;
        Ttemp2 := '   Y von '+YUntergr+' bis '+YObergr;
  T[6] := Ttemp1 + Ttemp2;
  T[7] := '1 Einheit entspricht '+einhS+'  cm';
  Text_ausgeben(T,7);                                 (* .. Texte ausgeben *)
  END;

PROCEDURE SumVt2D(V1,V2: Vt2D; VAR SV: Vt2D);
BEGIN
  SV.X := V1.X+V2.X;
  SV.Y := V1.Y+V2.Y;
END;

PROCEDURE DirectionVt2D(R,Phi: EXTENDED; VAR V: Vt2D);
BEGIN
  Phi := Phi*PI/180;
  V.X := R*COS(Phi);
  V.Y := R*SIN(Phi);
END;

PROCEDURE Define_Polygon(NPts:INTEGER; M:Pt2D; R,T0 : EXTENDED;
                         VAR Plg: Polygon);
  VAR
  N  : INTEGER;
  T  : EXTENDED; 
  DV : Vt2D;      (* Vektor vom Mittelpunkt M zu einem Polygonpunkt = Ecke *)
                                                 (* Umkreismittelpunkt = M *)
                               (* NPts = Anzahl der Ecken des Polygons     *)
                                  (* R = Radius des Umkreises des Polygons *)
                                 (* T0 = Anfangsversatzwinkel in Grad      *)
   BEGIN
    Plg.NNPts := NPts; 
    FOR N := 1 TO NPts DO BEGIN
      T := T0 + N/NPts * 360.0;    
      DirectionVt2D(R,T,DV);          (* gibt den Vektor DV zurueck        *)
      SumVt2D(M,DV,Plg.PtA[N]);       (* Ortsvektor der Polygonpunkte      *)
    END;                           
  END;

PROCEDURE Zeichnen(Plg:Polygon);
  VAR
  I,Color: INTEGER;
  BEGIN
  { IF Plot THEN WRITE(AUX,'PW'); }               (* Default Strichstaerke *)
    IF PLOT THEN WRITE(AUX,'PW0.1');                     (* duenner Strich *)
    Color := 15;
    MovetoPt2D(Plg.PtA[1]);
    FOR I := 2 TO Plg.NNPts DO BEGIN
      DrawtoPt2D(Plg.PtA[I],Color);
    END;
    DrawtoPt2D(Plg.PtA[1],Color);
  END;

PROCEDURE Polygonfamilie;
  VAR
  T0   : EXTENDED;             (* T0 = Anfangsversatzwinkel, wo liegt die  *)
                               (* erste Polygonecke ?                      *)
  R0,R : EXTENDED;             (* R0 = Radius des AusgangsPolygonUmkreises *)
  M    : Pt2D;                 (* M = Mittelpunkt des PolygonUmkreises     *)
  Ecken: INTEGER;              (* Anzahl der Ecken Dreieck, Fuenfeck, etc. *)
  J,JJ : INTEGER;              (* JJ = Anzahl der gezeichneten Polygone    *)
  Alpha,Delta,F : EXTENDED;
  AD : EXTENDED;     (* Anzahl der Drehungen, wie oft das AusgangsPolygon  *)
                     (* gedreht werden soll bezueglich des Endpolygons     *)
                   
  BEGIN
    Ecken := 4;
    M.X := -1.1; M.Y := 2.3;  R0 := 6.0;       (* Polygonumkreis           *)
    T0 :=   45.0;                              (* Anfangsversatzwinkel     *)
    Define_Polygon(Ecken, M, R0,T0,Plg1);
    Zeichnen(Plg1);
    AD := 1.5;        (* AusgangsPoly. wird ..mal gedreht bis zum EndPoly. *)
    JJ := 50;                               (* Polygongesamtanzahl         *)
                                            (* Alpha = DrehWinkel          *)
    Alpha := AD*2.0*Pi/Ecken/JJ;            (* zwischen 2 Polygonen        *)
    Delta := 2.0*Pi/Ecken/2.0;              (* Delta = halber Oeffnungs-   *)
                                            (* winkel zwischen 2 Ecken u.M *)
    F := COS(Delta)/COS(Alpha-Delta);       (* Verkleinerungsfaktor fuer   *)
                                            (* den Umkreisradius des P.    *)
    R := R0;                                (* Radius = Ausgangsradius     *)
    FOR J := 1 TO JJ DO BEGIN
      R := R*F*0.99;
      Define_Polygon(Ecken, M, R,(T0+J*Alpha*180.0/Pi),Plg1);
      Zeichnen(Plg1);
    END;        
    Beschriftung(Ecken,JJ+1,AD,Alpha*180.0/Pi,F,R0,T0,M);
  END;

{ -------------------------- Haupt-Programm ------------------------------ }
BEGIN
 Schnittstelle_waehlen(1);                 (* 2 bedeutet auf Datei plotten *)
  Plot := FALSE;                           (* 1 ist parallele Schnittst    *)
  einh := 2.0;   (* 1 Einheit auf der X-Achse und Y-Achse entspricht .. cm *)
  WI2D[1].X := -7.5;  WI2D[1].Y := -2.0;       (* linker unterer Punkt     *)
                                               (* des Weltfensters         *)
  Ausgangszustand_definieren;                  (* Graphikgrundeinstellung  *)
  Polygonfamilie;
  WClosegraph;
END.